= CHVote Threat model: CHVote platform
:imagesdir: ../../images
:title-logo-image: image:common/background.jpg[]
v0.1, 2018-03-22

:toc:

== Introduction

=== Scope

The scope of this threat model is the complete CHVote platform. It tries to dive not too deep into the details to keep
the study manageable. Further details are analyzed where needed on the relevant components, such as on the control
components.

Real cantons and printers are abstracted, the documented security measures relative to those entities should serve
as a starting point and as a reference for actual implementations.

=== Methodology

The document uses the link:https://www.owasp.org/index.php/Application_Threat_Modeling[OWASP application threat
modeling] method.

=== Relation to the SSDLC

The goal is to cover the link:++https://www.owasp.org/index.php/SAMM_-_Threat_Assessment_-_1++[OpenSAMM Threat Assessment
Level 1 maturity model].

=== Analyzed system description

TBD.

:architecture-overview-imagesdir: ../images/architecture
include::../architecture/architecture-overview.part.adoc[leveloffset=+1]

== External dependencies

[width="100%",cols="4%,96%",options="header",]
|=======================================================================
|ID |Description

|1 |Anti-DDOS filtering network: inbound network able to process a high load of requests coming from internet
and to discard packets bound to DOS traffic. The network does not have the CHVote TLS certificates.

|2 |OCSIN entry network: network appliances and telecommunication chanels connecting the Internet to the internal
OCSIN network. It consists of firewalls, IPS, optic fibers, etc.

|3 |Monitoring tools: common IT operations assets such as nagios and dynatrace used to monitor and handle the
incidents of the CHVote platform. Dynatrace is not used on the Control components.

|4 |Logical access controls: logical access controls are granted to the CHVote platform servers, except for
the control component. It uses a PAM (Privileged Access Management) tool in order to guarantee traceability
and 4-eyes access.

|5 |Physical access controls: the physical access to the server racks is protected with controls enforcing 4-eyes
principles for the control components, and personal identification and traceability for all the CHVote components.

|6 |SAN for Oracle databases: Oracle database use a common Storage Area Network

|7 |Certificate validation: the setup of the system applications
guarantees that they hold the correct certificates required to
authenticate communication partners and verify signatures. The applications use
these certificates explicitly without relying on a certification authority.

|8 |Certificate authority for TLS endpoints: the HTTPS endpoints are protected with a TLS certificate emitted by
an authorized certificate authority as required by VEleS.

|9 |Certificate authority for signatures: the files produced by the CHVote platform are signed with a certificate
emitted by an authorized certificate authority as required by VEleS.

|10 |Offline print chain: private network, servers and printers used to generate
the voting material.

|=======================================================================

== Entry points

TBD

[width="100%",cols="4%,18%,58%,20%",options="header",]
|=======================================================================
|ID |Name |Description |Trust levels
|1 |||

|=======================================================================

== Trusts levels

[width="100%",cols="4%,30%,66%",options="header",]
|=======================================================================
|ID |Name |Description
|1 |Anonymous user |A user who has connected to the system but has not
provided valid credentials.

|2 |Containerized application user |This is the user the backend or the backoffice application executes
code as. OpenShift platform prevents applications to run with a privileged level.

|3 |Message broker read/write user |The message broker account used to
exchange messages with the other services of the voting platform.

|4 |Database read/write user |The database user account used to access
the database for read and write access. Database user credentials are
different for each backend application, each one using its own schema.
The backoffice database runs on a distinct instance.

|5 |IT Operator |The IT operator has access to the health metrics of the
backend applications, and receive logs, nagios system checks and dynatrace
metrics.

|6 |System administrator | An administrator that has controlled access to the OpenShift
infrastructure: servers, hypervisor, virtual machines, operating system, OpenShift configuration
including secrets (database and message broker credentials, TLS certificates for backend communications),
containers registry, applications running in containers.

|7 |Database administrator | An administrator that has controlled access to the backend and backoffice
databases.

|8 |Voter | A voter using the CHVote platform to cast her vote.

|9 |Election officer | The administrator of an election or of a votation operation, working in an entity
responsible to prepare, run, and close the operation. He uses the Backoffice and the backend applications,
as well as some offline tools.

|10 |Printing authority | The printing authority has access to the Backoffice et uses some offline tools to
generate the voting material.

|11 |Election authority | An additional authority to the 4 control components, responsible to hold the fifth
key share of the ballots decryption key. It uses an offline tool to generate its key pair, and another one
to verify the proofs of the election.

|12 |Network administrator | An administrator that has controlled access to the network infrastructures
and to the Frontend.

|13 |IAM administrator | An administrator that has a privileged access to the IAM application and
the authorisations to create the users and their grants for the management entity access administrators.

|14 |Management entity access administrator | An administrator working for a management entity (canton, municipality),
that has a privileged access to the IAM application for its entity scope and the authorisations to
create the users and their grants.

|=======================================================================

<<<
== Assets

[width="100%",cols="9%,27%,41%a,23%",options="header"]
|=======================================================================
|ID |Name |Description |Trust levels

|**1** 3+|**Election data**

|1.1 |voters register file | eCH-0045 file
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (9) Election officer +
 (10) Printing authority

|1.2 |votation subjects | eCH-0159 file
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (9) Election officer +
 (10) Printing authority

|1.3 |election candidates and lists | eCH-0157 file
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (9) Election officer +
 (10) Printing authority

|1.4 |logistics data| Definitions of domain of influence, polling stations and printer configurations
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (9) Election office

|1.5 |electoral roll | The electoral roll of the voters eligible to electronic voting.
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|1.6.1 |private identification credentials
|The partial private identification credentials are generated by the control components and combined by the
 printing authority before being sent to the voters. They consist of a voter identifier and of a confirmation code.
|(8) Voter +
 (10) Printing authority

|1.6.2 |public identification credentials
|The partial public identification credentials are published by the
 control components on the bulletin board and then combined by each control component, to verify the proofs of the
 clients identity claims.
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|1.6.3 |verification code parts
|For each voter and candidate, each control component generates a secret value.
 Those values are then combined by the printing authority and displayed in a human readable format. They help the
 voter to detect vote manipulation attempts before submitting their final vote.
|(8) Voter +
 (10) Printing authority

|1.6.4 |finalization code parts
|For each voter, each control component generates a random secret value. Those
 values are then combined by the printing authority and displayed in a human readable format. They help the voter
 to detect vote pruning attempts by confirming the real server received the vote confirmation
|(8) Voter +
 (10) Printing authority

|1.7|additional client authentication data
|The data that the voter sends through the voting client in addition to the confirmation code to authenticate
 himself (date of birth).
|(8) Voter +
 (10) Printing authority

|1.8|additional server authentication data
|The data that the server stores for each voter to authenticate them along the confirmation code (HMAC of the
 date of birth).
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|1.9 |bulletin board
|Append-only log of the public protocol messages (signed by each sender where necessary).
 Used as a source for the verification of the election validity.
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|1.10 | printer archive
|The printer archive is a zip file that contains:

* the private identification credentials parts, the verification code parts and the finalization code
parts that are properly encrypted then signed so that only the right printer can decrypt and combine them;
* the eCH-0045 voters register file so that the voting cards can be printed with the voters' addresses,
polling stations' addresses, and so on;
* the votation subjects (eCH-0159 file), and the election candidates and lists (eCH-0157 file) needed
 to print the relevant information for each verification code on the voting cards.
|(2) Containerized application user +
 (6) System administrator +
 (10) Printing authority

|1.11 |voting card (paper)
|The voting card (paper) sent by postal mail to the voter. It includes the voter identifier,
 the confirmation code, the finalization code, the verification codes, and the voter's contact information.
|(8) Voter +
 (10) Printing authority

|1.12|cast vote
|The encrypted vote that the user casts through the voting client, with the proof of encryption.
|(8) Voter +
 (2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|1.13|counting archive
|A file containing:

 * the list of all the votes partially decrypted by each control component;
 * the proofs of the partial decryption;
 * the votation subjects (eCH-0159 file), and the election candidates and lists (eCH-0157 file)

in order to map the identifiers known by the voting protocol into business identifiers used for generating the results.

The counting archive is used by the U-Count application to generate the detailed (eCH-0222) and aggregated (eCH-0110)
results.
|(2) Containerized application user +
 (6) System administrator +
 (9) Election officer

|1.14|detailed results | eCH-0222 file | (9) Election officer

|1.15|aggregated results | eCH-0110 file | (9) Election officer

|1.16|counting archive with decryption and tally proofs
|The counting archive to which is added the proofs of the decryption with the election authority key and proofs
 of the tally.
|(9) Election officer +
 (11) Election authority

|1.17|business users grants
|The grants affected to the users of the business applications. This includes their roles and their
metadata such as their management entity.
|(13) IAM administrator +
 (14) Management entity access administrator

|1.18.1|business user client authentication data
|The authentication data that the business user provides to its client application to
authenticate himself through the CHVote IAM single sign-on: login, password, OTP
|(9) Election officer +
 (10) Printing authority +
 (13) IAM administrator +
 (14) Management entity access administrator

|1.18.2|business user server authentication data
|The authentication data that the CHVote IAM solution securely stores to authenticate the users:
login, password as PBKDF2 or another secured password storage algorithm (depends on the IAM solution),
OTP key.
|(2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|**2** 3+| **Configuration data**
|2.1 |online PDF documentation (FAQ, etc.)
|PDF files stored by the CHVote platform that the user can download
 through the voting client. Their intent is to help the voter to cast her vote (technical requirements, how to
 use the different codes, how to verify the cast vote), and to publish official information (ballots booklets for
 example)
|(9) Election officer +
 (2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (10) Voter

|2.2 |helpdesk contact information
|Email, phone number, physical address, days and hours of contact for the cantonal helpdesk.
|(9) Election officer +
 (2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (10) Voter

|2.3 |vote receiver texts and translations | Configurable texts to be displayed by the voting client.
|(9) Election officer,
 (2) Containerized application user,
 (6) System administrator,
 (7) Database administrator +
 (10) Voter

|2.4 |operation and ballots configuration
|Configuration to be used by the voting client (operation name, cantonal images, view configurations for an
 election, etc.).
|(9) Election officer +
 (2) Containerized application user +
 (6) System administrator +
 (7) Database administrator +
 (10) Voter

|**3** 3+| **Cryptographic assets**

|3.1.1   | printer files encryption private key
|Private key used to decrypt the private identification credentials parts, the verification code parts and the
 finalization code parts from the printer archive. It can be generated and held securely either by a printer
 (for the real voting cards), or by the election officer (for test cards) or by the IT support (for IT support
 cards).
|(10) Printing authority

|3.1.2   | printer files encryption public key
|Public key used by the control components to encrypt the private identification credentials parts, the verification
 code parts and the finalization code parts. It is generated  then provided to the CHVote Backoffice either
 by a printer (for the real voting cards), or by the election officer (for test cards) or by the IT support (for
 IT support cards).
|(10) Printing authority +
 (2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|3.2   | control component public keys
|Each control component private key has a matching public key that is provided to the printing authorities using
 a secure channel outside of the CHVote platform, so that the printing authorities can authenticate the source of
 the private identification credentials parts, the verification code parts and the finalization code parts.
|(10) Printing authority

|3.3.1   | election authority private ballot encryption key
|The (cantonal) election authority has its own private key that is used to make the final decryption of the
 mixed and partially decrypted ballots. This private key is shared using Shamir's secret sharing algorithm,
 so that n out of m representatives of the election authority can recover the private key. Each share is stored
 on a secured USB key, protected by a PIN number, a password or a fingerprint (depending on the chosen USB key
 solution).
|(11) Election authority

|3.3.2   | election authority public ballot encryption key
|The (cantonal) election authority publishes its ballot encryption public key that is combined with the 4 control
 components' public keys to become the ballot encryption key.
|(11) Election authority +
 (9) Election officer +
 (2) Containerized application user +
 (6) System administrator +
 (7) Database administrator

|3.4.1   a|election officer public certificate
|The (cantonal) election officer certificate used by the backend applications to validate the source of the
following business data:

* (1.1) voters register file
* (1.2) votation subjects
* (1.3) election candidates and lists
* (1.4) logistics data
* (2.1) online PDF documentation

|(9) Election officer +
 (2) Containerized application user +
 (6) System administrator +

|3.4.2   a|election officer signing private key
|The private key used by the election officer to sign the following business data on their computer before
being sent to the CHVote backoffice:

* (1.1) voters register file
* (1.2) votation subjects
* (1.3) election candidates and lists
* (1.4) logistics data
* (2.1) online PDF documentation

|(9) Election officer

|3.5.1   a|CHVote platform public certificate
|The CHVote platform certificate used by the election authorities and the printing authorities to validate
the source of the following business data:

* (1.10) printer archive
* (1.13) counting archive

|(6) System administrator +
 (9) Election officer

|3.5.2   a|CHVote platform signing private key
|The private key used by the CHVote backend applications to sign the following business data. It must not be
shared with the Backoffice application.

* (1.10) printer archive
* (1.13) counting archive

|(2) Containerized application user +
 (6) System administrator

//|3.6.1   a|Printer public certificate
//|The printer certificate used by the backend applications to validate the source of the
//following business data:
//
//* (1.1) voters register file
//* (1.2) votation subjects
//* (1.3) election candidates and lists
//* (1.4) logistics data
//* (2.1) online PDF documentation
//
//|(2) Containerized application user +
// (6) System administrator +

|**4** 3+| **IT assets**
|4.1.1   | voting client application
|Webapps running on the voter's browser.
|(2) Containerized application user +
 (6) System administrator +
 (8) Voter

|4.1.2   | backend and backoffice client applications
|Webapps running on the election officers' or printing authorities' browser.
|(2) Containerized application user +
 (6) System administrator +
 (9) Election officer +
 (10) Printing authority

|4.2   | server applications | Applications running on the server side.
|(2) Containerized application user +
 (6) System administrator

|4.3   | offline tools
|Offline desktop applications running on a election officer's, election authority's or
printing authority's computer. They are downloaded through the Backoffice application.
|(2) Containerized application user +
 (6) System administrator +
 (9) Election officer
 (10) Printing authority
 (11) Election authority

|4.4   | platform databases
|Databases containing schemas for each backend application (this excludes the control components).
|(7) Database administrator +
 (4) Database read/write user

|4.5   | platform middleware
|Support software for the CHVote platform: IAM system, RabbitMQ message broker, EFK log centralization.
|(3) Message broker read/write user +
 (6) System administrator

|4.7   | log files | Application logs, centralized to the EFK stack.
|(5) IT Operator +
 (6) System administrator

|4.8   | nagios system checks
|Nagios agents providing system health metrics to the IT operations team.
|(5) IT Operator +
 (6) System administrator

|4.9   | Dynatrace agent
|The Dynatrace agent is installed on each backend application to provide metrics (resource usages,
 services performances, services relationships) for system monitoring and incident handling.
|(5) IT Operator +
 (6) System administrator

|4.10 |chvote.ch TLS certificates
|TLS certificates issued by SwissSign ti establish the https endpoint for the online users. A certificate is
issued for the internet voting online application (www.chvote.ch), another for the administration applications
(admin.chvote.ch).
|(11) Network administrator

|**5** 3+| **Access and abilities assets**
|5.1 |Availability of the backend |_See the availability requirements of the System architecture
document._ |

|5.2 |Ability to access the PaaS infrastructure
|This is the ability to access the OpenShift infrastructure, the underlying operating systems, and the
hypervisor and to run commands or to change configurations.
|(6) System administrator

|5.3 |Ability to execute code as a backend application user |This is the
ability to execute the Java applications code on the backend.
|(2) Containerized application user

|5.4 |Ability to execute SQL as a Database Read/Write User |This is the
ability to execute SQL select, insert, and update queries on the
database and thus have read and write access to any information stored
within each backend application schema.
|(4) Database read/write user

|5.5 |Ability to receive or send messages |This is the ability to create
queues and exchanges, to bind queues to exchanges, to receive messages
from a queue or to publish messages into an exchange.
|(3) Message broker read/write user

|5.6 | Ability to access the Frontend
|This is the ability to access the frontend and to configure it (change routes to
 the right OpenShift instance, change TLS certificate)
|(12) Network administrator

|5.7 | Ability to access the databases
|This is the ability to access and manage the databases (backend and Backoffice)
|(7) Database administrator

|=======================================================================

== Data processing and storage locations

The following component breakdown aggregates the system components into the different trust boundaries.
In each trust boundary are defined the data assets that are processed or stored, for each of the following phases:

* Prepare: election or votation preparation, including: configuring the operation, testing, generating the voting
material, and initializing the ballot box.

* Run: running the operation, including voters casting vote, election officers marking voting cards received by postal
mail, following the vote participation.

* Count: getting the counting archive, decrypting it, establishing the counts, verifying the proofs.

* Close: deleting the operation once all remedies have been dealt with.

The data is either:

* In plain text: icon:font[]

* Encrypted: icon:lock[]

* Deleted: icon:trash[]

=== Voter device
The voter device is the personal computer or the mobile device (tablet, smartphone) used by voters to cast their
ballot.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close
|1.2   |votation subjects | | icon:font[] | icon:trash[] |
|1.3   |election candidates and lists | | icon:font[] | icon:trash[] |
|1.6.1 |private identification credentials | | icon:font[] | icon:trash[] |
|1.6.3 |verification code parts | | icon:font[] | icon:trash[] |
|1.6.4 |finalization code parts | | icon:font[] | icon:trash[] |
|1.7   |additional client authentication data | | icon:font[] | icon:trash[] |
|1.12  |cast vote | | icon:lock[] | icon:trash[] |
|2.1   |online PDF documentation (FAQ, etc.) | | icon:font[] | icon:trash[] |
|2.2   |helpdesk contact information | | icon:font[] | icon:trash[] |
|2.3   |vote receiver texts and translations | | icon:font[] | icon:trash[] |
|2.4   |operation and ballots configuration | | icon:font[] | icon:trash[] |
|=======================================================================

=== Frontend
The frontend is the server that communicates directly with the voter device via the Internet.
It is the endpoint of the TLS communications. It acts as a first layer Web Application Firewall (WAF)
and as an application router (routes URL to the relevant PaaS/OpenShift instance).

In the architecture diagram, the frontend consists of the "F5 Gateway".

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close
|1.1   |voters register file | icon:font[] | icon:trash[] | |
|1.2   |votation subjects | icon:font[] | icon:font[] | icon:trash[] |
|1.3   |election candidates and lists | icon:font[] | icon:font[] | icon:trash[] |
|1.4   |logistics data | icon:font[] | icon:trash[] | |
|1.6.3 |verification code parts | | icon:lock[] | icon:trash[] |
|1.6.4 |finalization code parts | | icon:lock[] | icon:trash[] |
|1.7   |additional client authentication data | | icon:font[] | icon:trash[] |

|1.10  |printer archive
|icon:lock[] private creds +
 icon:font[] others
|icon:trash[] | |

|1.12  |cast vote | | icon:lock[] | icon:trash[] |
|1.13  |counting archive | |
|icon:lock[] partially decrypted votes +
 icon:font[] others
|icon:trash[]

|1.18.1|business user client authentication data | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|2.1   |online PDF documentation (FAQ, etc.) | icon:font[] | icon:font[] | icon:trash[] |
|2.2   |helpdesk contact information | icon:font[] | icon:font[] | icon:trash[] |
|2.3   |vote receiver texts and translations | icon:font[] | icon:font[] | icon:trash[] |
|2.4   |operation and ballots configuration | icon:font[] | icon:font[] | icon:trash[] |
|3.1.2 |printer files encryption public key | icon:font[] | icon:trash[] | |
|3.3.2 |election authority public ballot encryption key | icon:font[] | icon:trash[] | |
|4.1.1 |voting client application | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.1.2 |backend and backoffice client applications | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.3   |offline tools | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.7   |log files | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.10  |chvote.ch TLS certificates | icon:lock[] | icon:lock[] | icon:lock[] | icon:lock[]
|5.6   |Ability to access the Frontend | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================


=== Backend
The backend consists of the servers running the containerized applications and the underlying OpenShift orchestrator
and its common services (routing, load balancing, log centralization), except the Backoffice application.

In the architecture diagram, the backend consists of the following components:

* PaaS (OpenShift), including its common services: HA Proxy for service routing and load balancing, EFK for logs
centralization and SIEM
* IAM and SSO
* Vote receiver
* PACT (Privileged Actions Control Tool)
* Vote usage management
* Operational monitoring
* Bulletin board
* Message broker (RabbitMQ)

Missing in this application view are those additional infrastructure components included in the backend definition:

* OpenShift worker and master nodes
* Virtual machines running the operating system for the OpenShift nodes
* Hypervisor running the virtual machines
* Servers running the hypervisors

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close
|1.1   |voters register file | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.2   |votation subjects | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.3   |election candidates and lists | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.4   |logistics data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.5   |electoral roll | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.6.2 |public identification credentials | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.6.3 |verification code parts | | icon:lock[] | icon:trash[] |
|1.6.4 |finalization code parts | | icon:lock[] | icon:trash[] |
|1.7   |additional client authentication data | | icon:font[] | icon:trash[] |
|1.8   |additional server authentication data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.9   |bulletin board | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|1.10  |printer archive
|icon:lock[] private creds +
 icon:font[] others
|icon:lock[] private creds +
 icon:font[] others
|icon:lock[] private creds +
 icon:font[] others
|icon:trash[]

|1.12  |cast vote | | icon:lock[] | icon:lock[] | icon:trash[]

|1.13  |counting archive
||
|icon:lock[] partially decrypted votes +
 icon:font[] others
|icon:trash[]

|1.17  |business users grants | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|1.18.1|business user client authentication data | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|1.18.2|business user server authentication data | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|2.1   |online PDF documentation (FAQ, etc.) | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.2   |helpdesk contact information | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.3   |vote receiver texts and translations | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.4   |operation and ballots configuration | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|3.1.2 |printer files encryption public key | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.3.2 |election authority public ballot encryption key | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|3.4.1 |election officer public certificate | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.5.2 |CHVote platform signing private key |  icon:lock[] | icon:lock[] | icon:lock[] | icon:lock[]

|4.1.1 |voting client application | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.1.2 |backend and backoffice client applications | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.2   |server applications | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.3   |offline tools | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.5   |platform middleware | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.7   |log files | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.8   |nagios system checks | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.9   |Dynatrace agent | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|5.2   |Ability to access the PaaS infrastructure | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|5.3   |Ability to execute code as a backend application user | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|5.4   |Ability to execute SQL as a Database Read/Write User | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|5.5   |Ability to receive or send messages | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================


=== Platform Database
The CHVote applications (except the _Backoffice_) share the same highly available database instance. Each application
uses its own schema and personal credential, so that an application cannot have direct access to the data of another
application.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close
|1.1   |voters register file | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.2   |votation subjects | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.3   |election candidates and lists | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.4   |logistics data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.5   |electoral roll | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.6.2 |public identification credentials | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.8   |additional server authentication data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.9   |bulletin board | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.12  |cast vote | | icon:lock[] | icon:lock[] | icon:trash[]
|1.17  |business users grants | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|1.18.2|business user server authentication data | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|2.1   |online PDF documentation (FAQ, etc.) | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.2   |helpdesk contact information | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.3   |vote receiver texts and translations | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.4   |operation and ballots configuration | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|3.1.2 |printer files encryption public key | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|3.3.2 |election authority public ballot encryption key | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|4.7   |log files | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.8   |nagios system checks | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|5.7   |Ability to access the databases | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================


=== Backoffice
The Backoffice consists of the containerized _Backoffice_ application running in the CHVote OpenShift orchestrator.
It lies within another trust boundary than the one of the other backend applications, because the application
fulfills different requirements to give shorter delivery iterations to this business critical application:

* It is treated as an external dependency for the other backend apps, deemed untrusted data wise.
* It can only communicate with the CHVote application via the PACT application, that acts as a security gateway
 (data and user actions validation).
* It does not have to conform to the VEleS requirements, e.g. it's functionality is not audited as per EAL2 standards.
* It conforms to OCSIN standards for security and testing requirements (e.g. this includes pentests, vulnerability tests
 and performance tests).

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close
|1.1   |voters register file | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.2   |votation subjects | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.3   |election candidates and lists | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.4   |logistics data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|1.10  |printer archive
|icon:lock[] private creds +
 icon:font[] others
|icon:lock[] private creds +
 icon:font[] others
|icon:lock[] private creds +
 icon:font[] others
|icon:trash[]

|2.1   |online PDF documentation (FAQ, etc.) | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.2   |helpdesk contact information | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.3   |vote receiver texts and translations | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.4   |operation and ballots configuration | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|3.1.2 |printer files encryption public key | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|3.3.2 |election authority public ballot encryption key | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|4.1.2 |backend and backoffice client applications | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.2   |server applications | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.3   |offline tools | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.7   |log files | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.8   |nagios system checks | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.9   |Dynatrace agent | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|5.2   |Ability to access the PaaS infrastructure | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|5.3   |Ability to execute code as a backend application user | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|5.4   |Ability to execute SQL as a Database Read/Write User | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

=== Backoffice Database
The backoffice uses its own database instance.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close
|1.1   |voters register file | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.2   |votation subjects | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.3   |election candidates and lists | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.4   |logistics data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.1   |online PDF documentation (FAQ, etc.) | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.2   |helpdesk contact information | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.3   |vote receiver texts and translations | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.4   |operation and ballots configuration | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|3.1.2 |printer files encryption public key | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|3.3.2 |election authority public ballot encryption key| icon:font[] | icon:font[] | icon:font[] | icon:font[]

|4.7   |log files | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|4.8   |nagios system checks | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|5.7   |Ability to access the databases | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

=== Control components
The control components consist of 4 independent clusters of 2 control components. Each has their own independent
key material, database and local storage.

See the _CHVote Threat model: Control components_ document for the detailed security analysis of this cornerstone
component.

=== Cantonal standard PC
It is a standard computer provided by the cantonal infrastructure, provisioned with:

* a tool to sign and verify signature and to encrypt and decrypt files
* an X509 certificate and its private key to sign files sent to the CHVote platform

It has access to the Internet in order to communicate with the CHVote Backoffice and PACT applications, and with
the certificate authorities revocation lists.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close

|1.1   |voters register file | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.2   |votation subjects | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.3   |election candidates and lists | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.4   |logistics data | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|1.18.1|business user client authentication data | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|2.1   |online PDF documentation (FAQ, etc.) | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.2   |helpdesk contact information | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.3   |vote receiver texts and translations | icon:font[] | icon:font[] | icon:font[] | icon:trash[]
|2.4   |operation and ballots configuration | icon:font[] | icon:font[] | icon:font[] | icon:trash[]

|3.3.2 |election authority public ballot encryption key | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.4.1 |election officer public certificate | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.4.2 |election officer signing private key | icon:lock[] | icon:lock[] | icon:lock[] | icon:lock[]
|3.5.1 |CHVote platform public certificate | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

=== Counting offline PC
It is a laptop dedicated to the process of decrypting the ballot box with the election authority key and of generating
the count. It uses the U-Count desktop application provided by the CHVote system. It is never connected to any network
during a voting operation.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close

|1.13  |counting archive
||
|icon:lock[] partially decrypted votes +
 icon:font[] others
|icon:trash[]
|1.14  |detailed results | | | icon:font[] | icon:trash[]
|1.15  |aggregated results | | | icon:font[] | icon:trash[]
|1.16  |counting archive with decryption and tally proofs | | | icon:font[] | icon:trash[]

|3.2   |control component public keys | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.3.1 |election authority private ballot encryption key | icon:lock[] | icon:lock[] | icon:lock[] | icon:lock[]
|3.3.2 |election authority public ballot encryption key | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|4.3   |offline tools | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

=== Verification offline PC
It is a laptop dedicated to the process of verifying the proofs of the voting protocol. It uses the U-Verify desktop
application provided by the CHVote system or any other third-party verification application that complies to the
protocol specification and to the counting archive file format. It is never connected to any network during a voting
operation.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close

|1.16  |counting archive with decryption and tally proofs | | | icon:font[] | icon:trash[]

|3.2   |control component public keys | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|4.3   | offline tools | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

=== Printing authority standard PC
It is a standard computer provided by the printing authority infrastructure, provisioned with:

* a tool to sign and verify signature and to encrypt and decrypt files
* an X509 certificate and its private key to sign files sent to the CHVote platform

It has access to the Internet in order to communicate with the CHVote Backoffice application, and with
the certificate authorities revocation lists.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close

|1.18.1|business user client authentication data | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|3.1.2 |printer files encryption public key | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.5.1 |CHVote platform public certificate | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

=== Printing authority offline PC
It is a laptop dedicated to the process of decrypting the printer archive and generating the clear-text voting
material in the form of a standardized eCH XML file. It uses the U-Print desktop application provided by the CHVote
system. It is never connected to any network during a voting operation, except the private network of the print
chain.

[width="100%",cols=".^8%,.^44%,^.^12%,^.^12%,^.^12%,^.^12%",options="header"]
|=======================================================================
|ID |Data Name | Prepare | Run | Count | Close

|1.10  |printer archive
|icon:lock[] private creds +
 icon:font[] others
|icon:trash[] | |

|3.1.1 | printer files encryption private key | icon:lock[] | icon:lock[] | icon:lock[] | icon:lock[]
|3.1.2 | printer files encryption public key | icon:font[] | icon:font[] | icon:font[] | icon:font[]
|3.2   |control component public keys | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|4.3   | offline tools | icon:font[] | icon:font[] | icon:font[] | icon:font[]

|=======================================================================

<<<
== Data flow diagram
TBD

== Threats

Threats are identified according to the STRIDE categorization model:

 * Spoofing: Threat action aimed to successfully misrepresent itself in a
way that fools a target into interacting with it as the misrepresented
system.

 * Tampering: Threat action aimed to maliciously change/modify
persistent data, such as persistent data in a database, and the
alteration of data in transit between two computers over an open
network, such as the Internet.

 * Repudiation: Threat action aimed to
perform illegal operations in a system that lacks the ability to trace
the prohibited operations.

 * Information Disclosure: Threat action to
read data that one was not granted access to, or to read data in
transit.

 * Denial of Service: Threat aimed to deny access to valid
users, such as by making a web server temporarily unavailable or
unusable.

 * Elevation of Privilege: Threat aimed to gain privileged
access to resources for gaining unauthorized access to information or to
compromise a system.

=== Spoofing Threats
TBD

=== Tampering Threats
TBD

=== Repudiation Threats
TBD

=== Information Disclosure Threats
TBD

=== Denial of Service Threats
TBD

=== Elevation of Privilege
TBD

== Risk ranking of threats

=== Risk calculation

[width="100%",cols="40%,12%,12%,12%,12%,12%",options="header",]
|=======================================================================
|Likelihood / Impact |0.5 Very unlikely |1 Unlikely |2 Probable |3
Highly probable |4 Almost certain
|4 Authorities credibility highly threatened |2 Low |4 Moderate |8 High
|12 High |16 High

|3 Authorities credibility moderately threatened |1.5 Low |3 Low |6
Moderate |9 High |12 High

|2 A ballot may not be completed |1 Low |2 Low |4 Moderate |6 Moderate
|8 High

|1 The VE is hardly questioned |0.5 Very low |1 Low |2 Low |3 Low |4
Moderate
|=======================================================================

=== Risk assessment matrix
TBD

[cols=",,,",options="header",]
|===============================================

|Threat Id |Likelihood (0.5-4) |Impact (1-4) |Risk
|S.1 |1 |1 |1 Low

|===============================================
